@Echo OFF
SETLocal EnableDelayedExpansion
CLS

Echo **************************************************************************
Echo Script to Collect Registry Information from Remote Computers 
Echo **************************************************************************

Echo Checking RegConfig.INI file in C:\DynamicQuery folder
SET ConfigFile=C:\DynamicQuery\RegConfig.INI
SET FoundORNot=
SET RunTime=%DATE% %TIME%

IF EXIST !ConfigFile! (
  Echo !ConfigFile! Found...
  SET FoundOrNot=YES
) ELSE (
  Echo ERROR: !ConfigFile! Not found...
  Echo Please make RegConfig.INI exists in the C:\DynamicQuery folder
  Echo Exiting...
  SET FoundOrNot=NO
)

SET RunOrNot=NO
SET ProcOrNot=NO

IF !FoundOrNot! == YES (

  Echo Checking the Log file and other information from RegConfig.INI file
  SET ScriptLog=
  SET RepoFile=
  SET CompFile=
  SET ThisRegKeyNow=
  SET ThisRegEntryNow=

  Find /i "ScriptLogFile" < !ConfigFile! > TempR.TXT 2>&1
  IF !ErrorLevel! == 0 (
     FOR /F "Tokens=1-2 delims==" %%L IN (TempR.TXT) DO SET ScriptLog=%%M
     Echo ScriptLog file is : !ScriptLog!
     SET RunOrNot=YES
  ) ELSE (
     Echo ERROR: ScriptLogFile Keyword not found in !ConfigFile!...
     Echo Exiting...
     SET RunOrNot=NO
  )

  IF !RunOrNot! == YES (
     IF EXIST !ScriptLog! DEL !ScriptLog!

     Echo !RunTime! ************************************************************************** >> !ScriptLog!
     Echo !RunTime! Running DynamicQuery.CMD now... >> !ScriptLog!
     Echo !RunTime! Script queried: RegConfig.INI to get Log file... >> !ScriptLog!
     Echo !RunTime! Log File found: !ScriptLog!... >> !ScriptLog!
     Echo !RunTime! Checking the computer file name now... >> !ScriptLog!

     IF EXIST TempR.TXT DEL TempR.TXT     
     Find /i "ComputerFile" < !ConfigFile! > TempR.TXT 2>&1
     IF !ErrorLevel! == 0 (
        FOR /F "Tokens=1-2 delims==" %%L IN (TempR.TXT) DO SET CompFile=%%M
        Echo Computer file is : !CompFile!
        Echo !RunTime! Computer File reported is: !CompFile! >> !ScriptLog!
        SET RunOrNot=YES
     ) ELSE (
        Echo !RunTime! ERROR: ComputerFile Keyword not found in !ConfigFile!... >> !ScriptLog!
        Echo !RunTime! Exiting... >> !ScriptLog!
        SET RunOrNot=NO
     )
  )

  IF !RunOrNot! == YES (
     Echo !RunTime! Checking Report File name now... >> !ScriptLog!

     IF EXIST TempR.TXT DEL TempR.TXT     
     Find /i "MyReportFile" < !ConfigFile! > TempR.TXT 2>&1
     IF !ErrorLevel! == 0 (
        FOR /F "Tokens=1-2 delims==" %%L IN (TempR.TXT) DO SET RepoFile=%%M
        Echo !RunTime! Report File reported is: !RepoFile! >> !ScriptLog!
        SET RunOrNot=YES
     ) ELSE (
        Echo !RunTime! ERROR: MyReportFile Keyword not found in !ConfigFile!... >> !ScriptLog!
        Echo !RunTime! Exiting... >> !ScriptLog!
        SET RunOrNot=NO
     )
  )

  IF !RunOrNot! == YES (
     Echo !RunTime! Checking Registry Key and Registry entry to query...>> !ScriptLog!

     IF EXIST TempR.TXT DEL TempR.TXT     
     Find /i "ThisREGKey" < !ConfigFile! > TempR.TXT 2>&1
     IF !ErrorLevel! == 0 (
        FOR /F "Tokens=1-2 delims==" %%L IN (TempR.TXT) DO SET ThisRegKeyNow=%%M
        Echo !RunTime! Registry Key to query reported is: !ThisRegKeyNow! >> !ScriptLog!
        SET RunOrNot=YES
     ) ELSE (
        Echo !RunTime! ERROR: ThisREGKey Keyword not found in !ConfigFile!... >> !ScriptLog!
        Echo !RunTime! Exiting... >> !ScriptLog!
        SET RunOrNot=NO
     )
  )
  
  IF !RunOrNot! == YES (
     Echo !RunTime! Checking Registry Entry to query...>> !ScriptLog!

     IF EXIST TempR.TXT DEL TempR.TXT     
     Find /i "ThisREGEntry" < !ConfigFile! > TempR.TXT 2>&1
     IF !ErrorLevel! == 0 (
        FOR /F "Tokens=1-2 delims==" %%L IN (TempR.TXT) DO SET ThisRegEntryNow=%%M
        Echo !RunTime! Registry Key to query reported is: !ThisRegEntryNow! >> !ScriptLog!
        SET RunOrNot=YES
     ) ELSE (
        Echo !RunTime! ERROR: ThisREGEntry Keyword not found in !ConfigFile!... >> !ScriptLog!
        Echo !RunTime! Exiting... >> !ScriptLog!
        SET RunOrNot=NO
     )
  )
  
)

IF !RunOrNot! == YES (
   Echo !RunTime! ************************************************************************** >> !ScriptLog!
   Echo !RunTime! Script found all the Keywoards in the RegConfig.INI file... >> !ScriptLog!
   Echo !RunTime! Now script will check Computer File : !CompFile!... >> !ScriptLog!
   
   IF EXIST !CompFile! (
      Echo !RunTime! !CompFile! Found... >> !ScriptLog!
      SET RunOrNot=YES
   ) ELSE (
      Echo !RunTime! ERROR: !CompFile! not found... >> !ScriptLog!
      SET RunOrNot=NO
   )
   
)

IF !RunOrNot! == YES (
   Echo !RunTime! ******************************************************************************* >> !ScriptLog!
   Echo !RunTime! SUCCESS : Script found all its files and Keywords in the RegConfig.INI file... >> !ScriptLog!
   Echo !RunTime! Final Configuration : >> !ScriptLog!
   Echo !RunTime! Registry KEY to query  : !ThisRegKeyNow! >> !ScriptLog!
   Echo !RunTime! Registry Entry to query: !ThisRegEntryNow! >> !ScriptLog!
   Echo !RunTime! Computer File to use   : !CompFile! >> !ScriptLog!
   Echo !RunTime! Report File to Create  : !RepoFile! >> !ScriptLog!
   Echo !RunTime! Script Log File Name   : !ScriptLog! >> !ScriptLog!
   Echo !RunTime! ******************************************************************************* >> !ScriptLog!
   SET ProcOrNot=YES
)

IF !ProcOrNot! == YES (
   Echo !RunTime! Counting total number of Computers to process... >> !ScriptLog!
   
   SET TotComp=
   For /f "Tokens=*" %%R IN (!CompFile!) DO SET /A TotComp=TotComp+1
   
   Echo !RunTime! Total Computers: !TotComp! >> !ScriptLog!

   IF !TotComp! == 0 (
      Echo !RunTime! ERROR: There are 0 Computers to run the script for... >> !ScriptLog!
      Echo !RunTime! Exiting... >> !ScriptLog!
      SET ProcOrNot=NO
   )
)

IF !ProcOrNot! == YES (
   Echo !RunTime! Finally getting confirmation from user to process the script... >> !ScriptLog!
   CLS

   Echo **************************************************************************
   Echo Script to fetch TimeOfLastScan, TimeOfLastVirus and PatternFileDate Values
   Echo **************************************************************************
   Echo Author           : Nirmal Sharma
   Echo Report File      : !RepoFile!
   Echo Script Log File  : !ScriptLog!
   Echo Computer File    : !CompFile!
   Echo Script Directory : C:\DynamicQuery
   Echo Registry KEY     : !ThisRegKeyNow!
   Echo Registry Entry   : !ThisRegEntryNow!
   Echo Total Computers  : !TotComp!
   Echo **************************************************************************
   SET /P UserConf=Do you want to Process Now? 

   SET ProcOrNot=NO
  
   IF !UserConf! == Y (
      SET ProcOrNot=YES
   )
)

IF !ProcOrNot! == YES (
   Echo !RunTime! ******************************************************************************* >> !ScriptLog!
   Echo !RunTime! Script will check the following for all computers: >> !ScriptLog!
   Echo !RunTime! ******************************************************************************* >> !ScriptLog!
   Echo !RunTime!  1. Check Computer Connectivity >> !ScriptLog!
   Echo !RunTime!  2. Check existence of Registry Key and Entry >> !ScriptLog!
   Echo !RunTime!  3. Get the registry value >> !ScriptLog!
   Echo !RunTime! ******************************************************************************* >> !ScriptLog!
   Echo !RunTime! Creating Report Header now... >> !ScriptLog!
   Echo !RunTime! Deleting existing Report File... >> !ScriptLog!

   IF EXIST !RepoFile! DEL !RepoFile!
   Echo * Dynamic Registry Query Script * Version 1.0 >> !RepoFile!
   Echo * Registry Query: !ThisRegKeyNow! * >> !RepoFile!
   Echo * Registry Entry: !ThisRegEntryNow! * >> !RepoFile!
   
   Echo Computer, Computer Status, Registry KEY Found?, Registry Entry Found?, Value Returned >> !RepoFile!
   
   Echo !RunTime! Processing script now on the remote computers... >> !ScriptLog!
   
   SET TotCNT=1
   SET TotReach=1
   SET TotUnReach=1
   SET TotRegFound=1
   SET TotRegNotFound=1

   FOR /F "Tokens=*" %%L IN (!CompFile!) DO (
      
     CLS

     Echo **************************************************************************
     Echo Script to fetch TimeOfLastScan, TimeOfLastVirus and PatternFileDate Values
     Echo **************************************************************************
     Echo Author           : Nirmal Sharma
     Echo Report File      : !RepoFile!
     Echo Script Log File  : !ScriptLog!
     Echo Computer File    : !CompFile!
     Echo Script Directory : C:\DynamicQuery
     Echo Registry KEY     : !ThisRegKeyNow!
     Echo Registry Entry   : !ThisRegEntryNow!
     Echo Total Computers  : !TotComp!  
     Echo **************************************************************************
     Echo Computer Status    
     Echo ---------------
     Echo Processed       : [!TotCNT!] [Reachable : !TotReach!] [Unreachable: !TotUnReach!]
     Echo Registry Found  : [!TotRegFound!] [Not Found : !TotRegNotFound!] 
     Echo **************************************************************************

  
     SET ThisComp=
     SET ThisComp=%%L

     Echo !RunTime! *** Running for Computer: !ThisComp! *** >> !ScriptLog!

     Echo Running for computer: !ThisComp! [ Total : !TotComp! / Processed : !TotCNT! ]
     Echo Checking Connectivity...
     Echo !RunTime!    Checking Connectivity... >> !ScriptLog!
     
     IF EXIST TempR.TXT DEL TempR.TXT
     IF EXIST TempD.TXT DEL TempD.TXT

     SET CompStat=
     SET ReachOrNot=
     SET RegKeyFound=
     SET RegEntFound=
     SET RegEntValue=
  
     Ping !ThisComp! -n 1 > TempR.TXT 2>&1
     Find /i "Repl" < TempR.TXT > TempD.TXT 2>&1
     IF !ErrorLevel! == 0 (
        Echo Computer is reachable... 
        Echo !RunTime!    Computer is reachable... >> !ScriptLog!
       
        SET /a TotReach=TotReach+1
        SET ReachOrNot=YES
        SET CompStat=Reachable
     ) ELSE ( 
        Echo Computer is NOT reachable... 
        Echo !RunTime!    ERROR: Computer is NOT reachable... >> !ScriptLog!
       
        SET /a TotUnReach=TotUnReach+1
        SET ReachOrNot=NO
        SET CompStat=Not Reachable
     )
     IF !ReachOrNot! == YES (
        Echo Running REG Query command now...
        Echo !RunTime!    Running REG Query command now... >> !ScriptLog!

        IF EXIST TempR.TXT DEL TempR.TXT
        IF EXIST TempD.TXT DEL TempD.TXT

        Echo !RunTime!    Checking Registry KEY First... >> !ScriptLog!
             
        REG Query "\\!ThisComp!\!ThisRegKeyNow!" > TempR.TXT 2>&1
        IF !ErrorLevel! == 0 (
	   SET RegKeyFound=Yes
 	   Echo !RunTime!    Registry Key found... >> !ScriptLog!
           Echo !RunTime!    Checking Registry Entry now... >> !ScriptLog!

	   IF EXIST TEmpR.TXT DEL TempR.TXT 
           REG Query "\\!ThisComp!\!ThisRegKeyNow!" /v "!ThisRegEntryNow!" > TempR.TXT 2>&1
           IF !ErrorLevel! == 0 (
              Echo !RunTime!    Registry Entry Found... >> !ScriptLog!
              SET RegEntFound=Yes
              Echo !RunTime!    Checking Registry Value now... >> !scriptLog!
              Find /i "!ThisRegEntryNow!" < TempR.TXT > TempD.TXT 2>&1

              FOR /F "Tokens=1-3* delims= " %%X IN (TempD.TXT) DO SET RegENTValue=%%Z
              Echo !RunTime!    Registry Entry Value returned is: !RegEntValue! >> !ScriptLog!

           ) ELSE (
              Echo !RunTime!    ERROR: Registry Entry NOT Found... >> !ScriptLog!
              SET RegEntFound=No
           )
        ) ELSE (
           SET RegKeyFound=No
 	   Echo !RunTime!    ERROR: Registry Key NOT found or REG Command returned error... >> !ScriptLog!
           Echo !RunTime!    Error Returned is: >> !ScriptLog!
           FOR /f "Tokens=*" %%Z IN (TempR.TXT) DO Echo !RunTime!   %%Z >> !ScriptLog!
        )           
        
        Echo !RunTime!    Finished processing for Computer: !ThisComp! >> !ScriptLog!
        Echo !RunTime! ********************************************************************** >> !SCriptLog!

     )

     Echo !ThisComp!, !CompStat!,!RegKeyFound!, !RegEntFound!, !RegEntValue! >> !RepoFile!

     SET /a TotCNT=TotCNT+1

  )

)


IF EXIST TempR.TXT DEL TempR.TXT
IF EXIST TempD.TXT DEL TempD.TXT

CLS

Echo **************************************************************************
Echo Script to fetch TimeOfLastScan, TimeOfLastVirus and PatternFileDate Values
Echo **************************************************************************
Echo Author           : Nirmal Sharma
Echo Report File      : !RepoFile!
Echo Script Log File  : !ScriptLog!
Echo Computer File    : !CompFile!
Echo Script Directory : C:\DynamicQuery
Echo Registry KEY     : !ThisRegKeyNow!
Echo Registry Entry   : !ThisRegEntryNow!
Echo Total Computers  : !TotComp!  
Echo **************************************************************************
Echo Computer Status    
Echo ---------------
Echo Processed       : [!TotCNT!] [Reachable : !TotReach!] [Unreachable: !TotUnReach!]
Echo Registry Found  : [!TotRegFound!] [Not Found : !TotRegNotFound!] 
Echo **************************************************************************

Echo Finished...
Echo Please check !RepoFile! for more information...


